package com.hfkj.dao;

import com.hfkj.entity.GoodsVpd;
import com.hfkj.entity.GoodsVpdExample.Criteria;
import com.hfkj.entity.GoodsVpdExample.Criterion;
import com.hfkj.entity.GoodsVpdExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class GoodsVpdSqlProvider {

    public String countByExample(GoodsVpdExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("goods_vpd");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(GoodsVpdExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("goods_vpd");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(GoodsVpd record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("goods_vpd");
        
        if (record.getSpecsId() != null) {
            sql.VALUES("specs_id", "#{specsId,jdbcType=BIGINT}");
        }
        
        if (record.getKey() != null) {
            sql.VALUES("`key`", "#{key,jdbcType=VARCHAR}");
        }
        
        if (record.getValidDay() != null) {
            sql.VALUES("valid_day", "#{validDay,jdbcType=INTEGER}");
        }
        
        if (record.getType() != null) {
            sql.VALUES("`type`", "#{type,jdbcType=INTEGER}");
        }
        
        if (record.getSource() != null) {
            sql.VALUES("`source`", "#{source,jdbcType=INTEGER}");
        }
        
        if (record.getJumpType() != null) {
            sql.VALUES("jump_type", "#{jumpType,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.VALUES("sales_end_time", "#{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getJumpUrl() != null) {
            sql.VALUES("jump_url", "#{jumpUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getAppid() != null) {
            sql.VALUES("appid", "#{appid,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(GoodsVpdExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("specs_id");
        sql.SELECT("`key`");
        sql.SELECT("valid_day");
        sql.SELECT("`type`");
        sql.SELECT("`source`");
        sql.SELECT("jump_type");
        sql.SELECT("sales_end_time");
        sql.SELECT("jump_url");
        sql.SELECT("appid");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("goods_vpd");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        GoodsVpd record = (GoodsVpd) parameter.get("record");
        GoodsVpdExample example = (GoodsVpdExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("goods_vpd");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getSpecsId() != null) {
            sql.SET("specs_id = #{record.specsId,jdbcType=BIGINT}");
        }
        
        if (record.getKey() != null) {
            sql.SET("`key` = #{record.key,jdbcType=VARCHAR}");
        }
        
        if (record.getValidDay() != null) {
            sql.SET("valid_day = #{record.validDay,jdbcType=INTEGER}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        }
        
        if (record.getSource() != null) {
            sql.SET("`source` = #{record.source,jdbcType=INTEGER}");
        }
        
        if (record.getJumpType() != null) {
            sql.SET("jump_type = #{record.jumpType,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getJumpUrl() != null) {
            sql.SET("jump_url = #{record.jumpUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getAppid() != null) {
            sql.SET("appid = #{record.appid,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("goods_vpd");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("specs_id = #{record.specsId,jdbcType=BIGINT}");
        sql.SET("`key` = #{record.key,jdbcType=VARCHAR}");
        sql.SET("valid_day = #{record.validDay,jdbcType=INTEGER}");
        sql.SET("`type` = #{record.type,jdbcType=INTEGER}");
        sql.SET("`source` = #{record.source,jdbcType=INTEGER}");
        sql.SET("jump_type = #{record.jumpType,jdbcType=INTEGER}");
        sql.SET("sales_end_time = #{record.salesEndTime,jdbcType=TIMESTAMP}");
        sql.SET("jump_url = #{record.jumpUrl,jdbcType=VARCHAR}");
        sql.SET("appid = #{record.appid,jdbcType=VARCHAR}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        GoodsVpdExample example = (GoodsVpdExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(GoodsVpd record) {
        SQL sql = new SQL();
        sql.UPDATE("goods_vpd");
        
        if (record.getSpecsId() != null) {
            sql.SET("specs_id = #{specsId,jdbcType=BIGINT}");
        }
        
        if (record.getKey() != null) {
            sql.SET("`key` = #{key,jdbcType=VARCHAR}");
        }
        
        if (record.getValidDay() != null) {
            sql.SET("valid_day = #{validDay,jdbcType=INTEGER}");
        }
        
        if (record.getType() != null) {
            sql.SET("`type` = #{type,jdbcType=INTEGER}");
        }
        
        if (record.getSource() != null) {
            sql.SET("`source` = #{source,jdbcType=INTEGER}");
        }
        
        if (record.getJumpType() != null) {
            sql.SET("jump_type = #{jumpType,jdbcType=INTEGER}");
        }
        
        if (record.getSalesEndTime() != null) {
            sql.SET("sales_end_time = #{salesEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getJumpUrl() != null) {
            sql.SET("jump_url = #{jumpUrl,jdbcType=VARCHAR}");
        }
        
        if (record.getAppid() != null) {
            sql.SET("appid = #{appid,jdbcType=VARCHAR}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, GoodsVpdExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}
